/**********************************************************************/
/*                                                                    */
/* The client part of a client-server pair.                           */
/**********************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

#define PORT 6789           
#define HOST "frodo.uccs.edu"
#define MSG  "run"
#define bufsize 20

int getopt(int argc, char * const argv[], const char *optstring);
extern char *optarg;
extern int optind, opterr, optopt;

void help_msg(char *prog);

/**********************************************************************/
/* Main                                                               */
/**********************************************************************/

int main (int argc,char *argv[])

{ struct sockaddr_in cin; 
  struct hostent *hp;
  char *buffer;
  char *host;
  //char tmpstr[50]="";
  int portno;
  int sd;
  int c;

//set default value
  host=HOST;
  buffer=MSG;
  portno=PORT;
  //fprintf(stdout,"%s,%d,%s\n",host,portno,buffer);

//parse command line parameters
while ((c=getopt(argc,argv,"hpm")) != EOF)
   {
     switch(c)
       {
        case 'h':
          host = argv[optind];
          //(void) fprintf(stdout,"hostname: %s \n",host);
          break;
       case 'p':
	 portno = atoi(argv[optind]);
         //(void) fprintf(stdout,"port #: %d \n",portno);
	 break;
       case 'm':
	 buffer = argv[optind];
	 //(void) fprintf(stdout,"message: %s \n",buffer);
	 break;
       default:
	 help_msg(argv[0]);
	 return (-1);
       }
  }

//sprintf(tmpstr,"%s",buffer);
//buffer=strcat(tmpstr,"\n");


if ((hp = gethostbyname(host)) == NULL)
 {
 perror("gethostbyname error: ");
 exit(1);
 }


memset(&cin,0,sizeof(cin));
cin.sin_family = AF_INET;
cin.sin_addr.s_addr = ((struct in_addr *)(hp->h_addr))->s_addr;
cin.sin_port = htons(portno);

if ((sd = socket(AF_INET,SOCK_STREAM,0)) == -1)
   {
   perror("socket");
   exit(1);
   }

if (connect(sd,(void *)&cin,sizeof(cin)) == -1)
   {
   perror("connect");
   exit(1);
   }

if (send(sd,buffer,strlen(buffer),0) == -1)
   {
   perror ("send");
   exit(1);
   }

printf("Send data <%s> to %s:%d  \n", buffer, host, portno);

//if (recv(sd,buffer,bufsize,0) == -1)
//   {
//   perror("recv");
//   exit (1);
//   }

//printf ("Server responded with %s\n",buffer);

close (sd);
}


void help_msg(char *prog)
{
  fprintf(stdout,"Usage : %s -h <hostname> -p <port no> -m <message> \n", prog);
  fprintf(stdout, "Deafult Setting\n host: %s, port: %d, message: %s \n",HOST, PORT, MSG);
  return;
}


