/*===============================
* This is a simple echo server. 
=================================*/
#include <stdio.h>
#include <errno.h>
#include <sys/socket.h>
#include <resolv.h>
#include <arpa/inet.h>
#include <errno.h>

#define PORT 9999
#define MAXBUF 1024


int main(int argc, char *argv[]) { 

int sockfd;
struct sockaddr_in self;
char buffer[MAXBUF];

int clientfd;
struct sockaddr_in client_addr;
int addrlen=sizeof(client_addr);

/*-----------------------------*/
/* Create streaming socket */
/*-----------------------------*/
if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0 ) {
    perror("Socket");
    exit(errno);
}

/*------------------------------------*/
/* Initialize address/port structure */
/*------------------------------------*/
bzero(&self, sizeof(self));
self.sin_family = AF_INET;
self.sin_port = htons(PORT);
self.sin_addr.s_addr = INADDR_ANY;

/*------------------------------------*/
/* Assign a port number to the socket */
/*------------------------------------*/
if ( bind(sockfd, (struct sockaddr*)&self, sizeof(self)) != 0 ) {
    perror("socket--bind");
    exit(errno);
}

/*----------------------------------*/
/* Make it a "listening socket" */
/*----------------------------------*/
if ( listen(sockfd, 20) != 0 ) {
    perror("socket--listen");
    exit(errno);
}

/*--------------------------------------------*/
/* accept a connection (creating a data pipe) */
/*--------------------------------------------*/
clientfd = accept(sockfd, (struct sockaddr*)&client_addr, &addrlen);
printf("%s:%d connected\n", inet_ntoa(client_addr.sin_addr), ntohs(client_addr.sin_port));

/*--------------------------*/
/* Echo back anything sent */
/*--------------------------*/
send(clientfd, buffer, recv(clientfd, buffer, MAXBUF, 0), 0);

/*--------------------------*/
/* Close data connection */
/*--------------------------*/
close(clientfd);

/*-----------------------------------*/
/* Clean up (should never get here!) */
/*-----------------------------------*/
close(sockfd);
return 0;
}



